]> git.ipfire.org Git - people/pmueller/ipfire-2.x.git/blame - make.sh
strip: use toolchain binary inside of chroot to strip
[people/pmueller/ipfire-2.x.git] / make.sh
CommitLineData
df5e82b3 1#!/bin/bash
df5e82b3
MT
2############################################################################
3# #
f8e5510c 4# This file is part of the IPFire Firewall. #
df5e82b3 5# #
f8e5510c 6# IPFire is free software; you can redistribute it and/or modify #
df5e82b3
MT
7# it under the terms of the GNU General Public License as published by #
8# the Free Software Foundation; either version 2 of the License, or #
9# (at your option) any later version. #
10# #
f8e5510c 11# IPFire is distributed in the hope that it will be useful, #
df5e82b3
MT
12# but WITHOUT ANY WARRANTY; without even the implied warranty of #
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14# GNU General Public License for more details. #
15# #
16# You should have received a copy of the GNU General Public License #
f8e5510c 17# along with IPFire; if not, write to the Free Software #
df5e82b3
MT
18# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19# #
f7a48dd3 20# Copyright (C) 2007-2017 IPFire Team <info@ipfire.org>. #
df5e82b3
MT
21# #
22############################################################################
df5e82b3
MT
23#
24
e8ee3199
AF
25NAME="IPFire" # Software name
26SNAME="ipfire" # Short name
33513817 27VERSION="2.19" # Version number
bb3272da 28CORE="117" # Core Level (Filename)
4f248f7a 29PAKFIRE_CORE="116" # Core Level (PAKFIRE)
595e89a8 30GIT_BRANCH=`git rev-parse --abbrev-ref HEAD` # Git Branch
e8ee3199
AF
31SLOGAN="www.ipfire.org" # Software slogan
32CONFIG_ROOT=/var/ipfire # Configuration rootdir
33NICE=10 # Nice level
34MAX_RETRIES=1 # prefetch/check loop
305a7b38 35BUILD_IMAGES=1 # Flash and Xen Downloader
15679d9f 36KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
e8ee3199
AF
37GIT_TAG=$(git tag | tail -1) # Git Tag
38GIT_LASTCOMMIT=$(git log | head -n1 | cut -d" " -f2 |head -c8) # Last commit
628e8c3a 39
6c4cc7ea 40TOOLCHAINVER=20171121
03ad5f93 41
69a6ec55
MT
42###############################################################################
43#
44# Beautifying variables & presentation & input output interface
45#
46###############################################################################
47
f9783277
MT
48# Remember if the shell is interactive or not
49if [ -t 0 ] && [ -t 1 ]; then
50 INTERACTIVE=true
51else
52 INTERACTIVE=false
53fi
54
401a1edc
MT
55# Sets or adjusts pretty formatting variables
56resize_terminal() {
57 ## Screen Dimentions
58 # Find current screen size
59 COLUMNS=$(tput cols)
60
61 # When using remote connections, such as a serial port, stty size returns 0
62 if ! ${INTERACTIVE} || [ "${COLUMNS}" = "0" ]; then
63 COLUMNS=80
64 fi
69a6ec55 65
401a1edc
MT
66 # Measurements for positioning result messages
67 OPTIONS_WIDTH=20
68 TIME_WIDTH=12
69 STATUS_WIDTH=8
70 NAME_WIDTH=$(( COLUMNS - OPTIONS_WIDTH - TIME_WIDTH - STATUS_WIDTH ))
71 LINE_WIDTH=$(( COLUMNS - STATUS_WIDTH ))
72
e9a57acd
MT
73 TIME_COL=$(( NAME_WIDTH + OPTIONS_WIDTH ))
74 STATUS_COL=$(( TIME_COL + TIME_WIDTH ))
401a1edc 75}
69a6ec55 76
401a1edc
MT
77# Initially setup terminal
78resize_terminal
f9783277 79
401a1edc
MT
80# Call resize_terminal when terminal is being resized
81trap "resize_terminal" WINCH
69a6ec55
MT
82
83# Define color for messages
84BOLD="\\033[1;39m"
85DONE="\\033[1;32m"
86SKIP="\\033[1;34m"
87WARN="\\033[1;35m"
88FAIL="\\033[1;31m"
89NORMAL="\\033[0;39m"
90
bcb9dc13 91# New architecture variables
dc7d6b20 92HOST_ARCH="$(uname -m)"
94571564 93
69a6ec55
MT
94PWD=$(pwd)
95BASENAME=$(basename $0)
96
15679d9f
MT
97# Debian specific settings
98if [ ! -e /etc/debian_version ]; then
df5e82b3 99 FULLPATH=`which $0`
15679d9f 100else
df5e82b3
MT
101 if [ -x /usr/bin/realpath ]; then
102 FULLPATH=`/usr/bin/realpath $0`
103 else
104 echo "ERROR: Need to do apt-get install realpath"
105 exit 1
106 fi
15679d9f 107fi
df5e82b3 108
69a6ec55 109# This is the directory where make.sh is in
aecbe123 110export BASEDIR=$(echo $FULLPATH | sed "s/\/$BASENAME//g")
69a6ec55 111
15679d9f 112LOGFILE=$BASEDIR/log/_build.preparation.log
aecbe123 113export LOGFILE
15679d9f
MT
114DIR_CHK=$BASEDIR/cache/check
115mkdir $BASEDIR/log/ 2>/dev/null
df5e82b3 116
69a6ec55
MT
117system_processors() {
118 getconf _NPROCESSORS_ONLN 2>/dev/null || echo "1"
119}
120
121system_memory() {
122 local key val unit
123
124 while read -r key val unit; do
125 case "${key}" in
126 MemTotal:*)
127 # Convert to MB
128 echo "$(( ${val} / 1024 ))"
129 break
130 ;;
131 esac
132 done < /proc/meminfo
133}
134
135configure_build() {
136 local build_arch="${1}"
137
138 if [ "${build_arch}" = "default" ]; then
139 build_arch="$(configure_build_guess)"
140 fi
141
142 case "${build_arch}" in
143 x86_64)
144 BUILDTARGET="${build_arch}-unknown-linux-gnu"
145 CROSSTARGET="${build_arch}-cross-linux-gnu"
146 BUILD_PLATFORM="x86"
147 CFLAGS_ARCH="-m64 -mtune=generic"
148 ;;
149
150 i586)
151 BUILDTARGET="${build_arch}-pc-linux-gnu"
152 CROSSTARGET="${build_arch}-cross-linux-gnu"
153 BUILD_PLATFORM="x86"
154 CFLAGS_ARCH="-march=i586 -mtune=generic -fomit-frame-pointer"
155 ;;
156
157 aarch64)
158 BUILDTARGET="${build_arch}-unknown-linux-gnu"
159 CROSSTARGET="${build_arch}-cross-linux-gnu"
160 BUILD_PLATFORM="arm"
161 CFLAGS_ARCH=""
162 ;;
163
164 armv7hl)
165 BUILDTARGET="${build_arch}-unknown-linux-gnueabi"
166 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
167 BUILD_PLATFORM="arm"
168 CFLAGS_ARCH="-march=armv7-a -mfpu=vfpv3-d16 -mfloat-abi=hard"
169 ;;
170
171 armv5tel)
172 BUILDTARGET="${build_arch}-unknown-linux-gnueabi"
173 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
174 BUILD_PLATFORM="arm"
175 CFLAGS_ARCH="-march=armv5te -mfloat-abi=soft -fomit-frame-pointer"
176 ;;
177
178 *)
179 exiterror "Cannot build for architure ${build_arch}"
180 ;;
181 esac
182
183 # Check if the QEMU helper is available if needed.
184 if qemu_is_required "${build_arch}"; then
185 local qemu_build_helper="$(qemu_find_build_helper_name "${build_arch}")"
186
187 if [ -n "${qemu_build_helper}" ]; then
188 QEMU_TARGET_HELPER="${qemu_build_helper}"
189 else
190 exiterror "Could not find a binfmt_misc helper entry for ${build_arch}"
191 fi
192 fi
193
194 BUILD_ARCH="${build_arch}"
195 TOOLS_DIR="/tools_${BUILD_ARCH}"
196
197 # Enables hardening
198 HARDENING_CFLAGS="-Wp,-D_FORTIFY_SOURCE=2 -fstack-protector-strong --param=ssp-buffer-size=4"
199
200 CFLAGS="-O2 -pipe -Wall -fexceptions -fPIC ${CFLAGS_ARCH}"
201 CXXFLAGS="${CFLAGS}"
202
203 # Determine parallelism
204 if [ -z "${MAKETUNING}" ]; then
205 # We assume that each process consumes about
206 # 192MB of memory. Therefore we find out how
207 # many processes fit into memory.
208 local mem_max=$(( ${HOST_MEM} / 192 ))
209
210 local processors="$(system_processors)"
211 local cpu_max=$(( ${processors} * 2 ))
212
213 local parallelism
214 if [ ${mem_max} -lt ${cpu_max} ]; then
215 parallelism=${mem_max}
216 else
217 parallelism=${cpu_max}
218 fi
219
220 MAKETUNING="-j${parallelism}"
221 fi
222}
223
224configure_build_guess() {
225 case "${HOST_ARCH}" in
226 x86_64|i686|i586)
227 echo "i586"
228 ;;
229
230 aarch64)
231 echo "aarch64"
232 ;;
233
234 armv7*|armv6*|armv5*)
235 echo "armv5tel"
236 ;;
237
238 *)
239 exiterror "Cannot guess build architecture"
240 ;;
241 esac
242}
243
f9783277
MT
244stdumount() {
245 umount $BASEDIR/build/sys 2>/dev/null;
246 umount $BASEDIR/build/dev/shm 2>/dev/null;
247 umount $BASEDIR/build/dev/pts 2>/dev/null;
248 umount $BASEDIR/build/dev 2>/dev/null;
249 umount $BASEDIR/build/proc 2>/dev/null;
250 umount $BASEDIR/build/install/mnt 2>/dev/null;
251 umount $BASEDIR/build/usr/src/cache 2>/dev/null;
252 umount $BASEDIR/build/usr/src/ccache 2>/dev/null;
253 umount $BASEDIR/build/usr/src/config 2>/dev/null;
254 umount $BASEDIR/build/usr/src/doc 2>/dev/null;
255 umount $BASEDIR/build/usr/src/html 2>/dev/null;
256 umount $BASEDIR/build/usr/src/langs 2>/dev/null;
257 umount $BASEDIR/build/usr/src/lfs 2>/dev/null;
258 umount $BASEDIR/build/usr/src/log 2>/dev/null;
259 umount $BASEDIR/build/usr/src/src 2>/dev/null;
260}
261
262now() {
263 date -u "+%s"
69a6ec55
MT
264}
265
f9783277
MT
266format_runtime() {
267 local seconds=${1}
268
269 if [ ${seconds} -ge 3600 ]; then
270 printf "%d:%02d:%02d\n" \
271 "$(( seconds / 3600 ))" \
272 "$(( seconds % 3600 / 60 ))" \
273 "$(( seconds % 3600 % 60 ))"
274 elif [ ${seconds} -ge 60 ]; then
275 printf "%d:%02d\n" \
276 "$(( seconds / 60 ))" \
277 "$(( seconds % 60 ))"
69a6ec55 278 else
f9783277 279 printf "%d\n" "${seconds}"
69a6ec55 280 fi
f9783277 281}
69a6ec55 282
f9783277
MT
283print_line() {
284 local line="$@"
69a6ec55 285
f9783277 286 printf "%-${LINE_WIDTH}s" "${line}"
69a6ec55
MT
287}
288
f9783277
MT
289_print_line() {
290 local status="${1}"
291 shift
69a6ec55 292
f9783277
MT
293 if ${INTERACTIVE}; then
294 printf "${!status}"
295 fi
69a6ec55 296
f9783277
MT
297 print_line "$@"
298
299 if ${INTERACTIVE}; then
300 printf "${NORMAL}"
301 fi
302}
303
304print_headline() {
305 _print_line BOLD "$@"
69a6ec55
MT
306}
307
f9783277
MT
308print_error() {
309 _print_line FAIL "$@"
310}
311
312print_package() {
313 local name="${1}"
314 shift
69a6ec55 315
f9783277
MT
316 local version="$(grep -E "^VER |^VER=|^VER " $BASEDIR/lfs/${name} | awk '{ print $3 }')"
317 local options="$@"
318
319 local string="${name}"
320 if [ -n "${version}" ] && [ "${version}" != "ipfire" ]; then
321 string="${string} (${version})"
322 fi
323
324 printf "%-$(( ${NAME_WIDTH} - 1 ))s " "${string}"
fa8c758e 325 printf "%$(( ${OPTIONS_WIDTH} - 1 ))s " "${options}"
f9783277
MT
326}
327
328print_runtime() {
329 local runtime=$(format_runtime $@)
330
331 if ${INTERACTIVE}; then
332 printf "\\033[${TIME_COL}G[ ${BOLD}%$(( ${TIME_WIDTH} - 4 ))s${NORMAL} ]" "${runtime}"
333 else
334 printf "[ %$(( ${TIME_WIDTH} - 4 ))s ]" "${runtime}"
69a6ec55 335 fi
f9783277
MT
336}
337
338print_status() {
339 local status="${1}"
340
341 local color="${!status}"
342
343 if ${INTERACTIVE}; then
344 printf "\\033[${STATUS_COL}G[${color-${BOLD}} %-$(( ${STATUS_WIDTH} - 4 ))s ${NORMAL}]\n" "${status}"
345 else
346 printf "[ %-$(( ${STATUS_WIDTH} - 4 ))s ]\n" "${status}"
69a6ec55 347 fi
f9783277 348}
69a6ec55 349
f9783277
MT
350print_build_stage() {
351 print_headline "$@"
352
353 # end line
354 printf "\n"
69a6ec55
MT
355}
356
f9783277
MT
357print_build_summary() {
358 local runtime=$(format_runtime $@)
359
360 print_line "*** Build finished in ${runtime}"
361 print_status DONE
69a6ec55
MT
362}
363
364exiterror() {
365 stdumount
366 for i in `seq 0 7`; do
367 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
368 losetup -d /dev/loop${i} 2>/dev/null
369 fi;
370 done
371
f9783277 372 # Dump logfile
66028310 373 if [ -n "${LOGFILE}" ] && [ -e "${LOGFILE}" ]; then
69a6ec55
MT
374 echo # empty line
375
376 local line
377 while read -r line; do
378 echo " ${line}"
379 done <<< "$(tail -n30 ${LOGFILE})"
380 fi
381
f9783277
MT
382 echo # empty line
383
384 local line
385 for line in "ERROR: $@" " Check ${LOGFILE} for errors if applicable"; do
386 print_error "${line}"
387 print_status FAIL
388 done
389
69a6ec55
MT
390 exit 1
391}
392
aecbe123
MT
393prepareenv() {
394 # Are we running the right shell?
54328605 395 if [ -z "${BASH}" ]; then
aecbe123
MT
396 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
397 fi
398
399 if [ -z "${BASH_VERSION}" ]; then
400 exiterror "Not running BASH shell."
401 fi
402
403 # Trap on emergency exit
404 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
405
406 # Resetting our nice level
658232a6 407 if ! renice ${NICE} $$ >/dev/null; then
658232a6 408 exiterror "Failed to set nice level to ${NICE}"
aecbe123
MT
409 fi
410
411 # Checking if running as root user
658232a6 412 if [ $(id -u) -ne 0 ]; then
aecbe123 413 exiterror "Not building as root"
aecbe123
MT
414 fi
415
416 # Checking for necessary temporary space
f9783277 417 print_line "Checking for necessary space on disk $BASE_DEV"
aecbe123
MT
418 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
419 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
420 if (( 2048000 > $BASE_ASPACE )); then
421 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
422 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
f9783277 423 print_status FAIL
aecbe123
MT
424 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
425 fi
426 else
f9783277 427 print_status DONE
aecbe123
MT
428 fi
429
430 # Set umask
431 umask 022
432
433 # Set LFS Directory
434 LFS=$BASEDIR/build
435
aecbe123
MT
436 # Setup environment
437 set +h
438 LC_ALL=POSIX
439 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
440 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
441
442 # Make some extra directories
443 mkdir -p "${BASEDIR}/build${TOOLS_DIR}" 2>/dev/null
444 mkdir -p $BASEDIR/build/{etc,usr/src} 2>/dev/null
445 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
446 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
447 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
448
449 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
450 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
451
452 # Make all sources and proc available under lfs build
453 mount --bind /dev $BASEDIR/build/dev
454 mount --bind /dev/pts $BASEDIR/build/dev/pts
455 mount --bind /dev/shm $BASEDIR/build/dev/shm
456 mount --bind /proc $BASEDIR/build/proc
457 mount --bind /sys $BASEDIR/build/sys
458 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
459 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
460 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
461 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
462 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
463 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
464 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
465 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
466 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
467
468 # Run LFS static binary creation scripts one by one
469 export CCACHE_DIR=$BASEDIR/ccache
470 export CCACHE_COMPRESS=1
471 export CCACHE_COMPILERCHECK="string:toolchain-${TOOLCHAINVER} ${BUILD_ARCH}"
472
473 # Remove pre-install list of installed files in case user erase some files before rebuild
474 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
475
476 # Prepare string for /etc/system-release.
477 SYSTEM_RELEASE="${NAME} ${VERSION} (${BUILD_ARCH})"
478 if [ "$(git status -s | wc -l)" == "0" ]; then
479 GIT_STATUS=""
480 else
481 GIT_STATUS="-dirty"
482 fi
483 case "$GIT_BRANCH" in
484 core*|beta?|rc?)
485 SYSTEM_RELEASE="${SYSTEM_RELEASE} - $GIT_BRANCH$GIT_STATUS"
486 ;;
487 *)
488 SYSTEM_RELEASE="${SYSTEM_RELEASE} - Development Build: $GIT_BRANCH/$GIT_LASTCOMMIT$GIT_STATUS"
489 ;;
490 esac
491}
492
69a6ec55
MT
493enterchroot() {
494 # Install QEMU helper, if needed
495 qemu_install_helper
496
497 local PATH="${TOOLS_DIR}/ccache/bin:/bin:/usr/bin:/sbin:/usr/sbin:${TOOLS_DIR}/bin"
498
499 PATH="${PATH}" chroot ${LFS} env -i \
500 HOME="/root" \
501 TERM="${TERM}" \
502 PS1="${PS1}" \
503 PATH="${PATH}" \
504 SYSTEM_RELEASE="${SYSTEM_RELEASE}" \
505 PAKFIRE_CORE="${PAKFIRE_CORE}" \
506 NAME="${NAME}" \
507 SNAME="${SNAME}" \
508 VERSION="${VERSION}" \
509 CORE="${CORE}" \
510 SLOGAN="${SLOGAN}" \
511 TOOLS_DIR="${TOOLS_DIR}" \
512 CONFIG_ROOT="${CONFIG_ROOT}" \
513 CFLAGS="${CFLAGS} ${HARDENING_CFLAGS}" \
514 CXXFLAGS="${CXXFLAGS} ${HARDENING_CFLAGS}" \
515 BUILDTARGET="${BUILDTARGET}" \
516 CROSSTARGET="${CROSSTARGET}" \
517 BUILD_ARCH="${BUILD_ARCH}" \
518 BUILD_PLATFORM="${BUILD_PLATFORM}" \
519 CCACHE_DIR=/usr/src/ccache \
520 CCACHE_COMPRESS="${CCACHE_COMPRESS}" \
521 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
522 KVER="${KVER}" \
523 $(fake_environ) \
524 $(qemu_environ) \
525 "$@"
526}
527
528entershell() {
529 if [ ! -e $BASEDIR/build/usr/src/lfs/ ]; then
530 exiterror "No such file or directory: $BASEDIR/build/usr/src/lfs/"
531 fi
532
533 echo "Entering to a shell inside LFS chroot, go out with exit"
534 local PS1="ipfire build chroot ($(uname -m)) \u:\w\$ "
535
536 if enterchroot bash -i; then
537 stdumount
538 else
f9783277 539 print_status FAIL
69a6ec55
MT
540 exiterror "chroot error"
541 fi
542}
543
544lfsmakecommoncheck() {
545 # Script present?
546 if [ ! -f $BASEDIR/lfs/$1 ]; then
547 exiterror "No such file or directory: $BASEDIR/$1"
548 fi
549
f9783277
MT
550 # Print package name and version
551 print_package $@
69a6ec55
MT
552
553 # Check if this package is supported by our architecture.
554 # If no SUP_ARCH is found, we assume the package can be built for all.
555 if grep "^SUP_ARCH" ${BASEDIR}/lfs/${1} >/dev/null; then
556 # Check if package supports ${BUILD_ARCH} or all architectures.
557 if ! grep -E "^SUP_ARCH.*${BUILD_ARCH}|^SUP_ARCH.*all" ${BASEDIR}/lfs/${1} >/dev/null; then
405ee2b4 558 print_runtime 0
f9783277 559 print_status SKIP
69a6ec55
MT
560 return 1
561 fi
562 fi
563
564 # Script slipped?
565 local i
566 for i in $SKIP_PACKAGE_LIST
567 do
568 if [ "$i" == "$1" ]; then
f9783277 569 print_status SKIP
69a6ec55
MT
570 return 1;
571 fi
572 done
573
574 echo -ne "`date -u '+%b %e %T'`: Building $* " >> $LOGFILE
575
576 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
577 MESSAGE="$1\t " download >> $LOGFILE 2>&1
578 if [ $? -ne 0 ]; then
579 exiterror "Download error in $1"
580 fi
581
582 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
583 MESSAGE="$1\t md5sum" md5 >> $LOGFILE 2>&1
584 if [ $? -ne 0 ]; then
585 exiterror "md5sum error in $1, check file in cache or signature"
586 fi
587
588 return 0 # pass all!
589}
590
591lfsmake1() {
592 lfsmakecommoncheck $*
593 [ $? == 1 ] && return 0
594
69a6ec55
MT
595 cd $BASEDIR/lfs && env -i \
596 PATH="${TOOLS_DIR}/ccache/bin:${TOOLS_DIR}/bin:$PATH" \
597 CCACHE_DIR="${CCACHE_DIR}" \
598 CCACHE_COMPRESS="${CCACHE_COMPRESS}" \
599 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
600 CFLAGS="${CFLAGS}" \
601 CXXFLAGS="${CXXFLAGS}" \
602 MAKETUNING="${MAKETUNING}" \
603 make -f $* \
604 TOOLCHAIN=1 \
605 TOOLS_DIR="${TOOLS_DIR}" \
606 CROSSTARGET="${CROSSTARGET}" \
607 BUILDTARGET="${BUILDTARGET}" \
608 BUILD_ARCH="${BUILD_ARCH}" \
609 BUILD_PLATFORM="${BUILD_PLATFORM}" \
610 LFS_BASEDIR="${BASEDIR}" \
611 ROOT="${LFS}" \
612 KVER="${KVER}" \
f9783277 613 install >> $LOGFILE 2>&1 &
69a6ec55 614
f9783277
MT
615 if ! wait_until_finished $!; then
616 print_status FAIL
617 exiterror "Building $*"
69a6ec55
MT
618 fi
619
f9783277 620 print_status DONE
69a6ec55
MT
621}
622
623lfsmake2() {
624 lfsmakecommoncheck $*
625 [ $? == 1 ] && return 0
626
69a6ec55
MT
627 local PS1='\u:\w$ '
628
629 enterchroot \
ce9264a1 630 ${EXTRA_PATH}bash -x -c "cd /usr/src/lfs && \
69a6ec55
MT
631 MAKETUNING=${MAKETUNING} \
632 make -f $* \
633 LFS_BASEDIR=/usr/src install" \
f9783277 634 >> ${LOGFILE} 2>&1 &
69a6ec55 635
f9783277
MT
636 if ! wait_until_finished $!; then
637 print_status FAIL
638 exiterror "Building $*"
69a6ec55
MT
639 fi
640
f9783277 641 print_status DONE
69a6ec55
MT
642}
643
644ipfiredist() {
645 lfsmakecommoncheck $*
646 [ $? == 1 ] && return 0
647
69a6ec55
MT
648 local PS1='\u:\w$ '
649
650 enterchroot \
651 bash -x -c "cd /usr/src/lfs && make -f $* LFS_BASEDIR=/usr/src dist" \
f9783277 652 >> ${LOGFILE} 2>&1 &
69a6ec55 653
f9783277
MT
654 if ! wait_until_finished $!; then
655 print_status FAIL
656 exiterror "Packaging $*"
657 fi
69a6ec55 658
f9783277
MT
659 print_status DONE
660}
661
662wait_until_finished() {
663 local pid=${1}
664
665 local start_time=$(now)
666
667 # Show progress
668 if ${INTERACTIVE}; then
669 # Wait a little just in case the process
670 # has finished very quickly.
671 sleep 0.1
672
673 local runtime
674 while kill -0 ${pid} 2>/dev/null; do
675 print_runtime $(( $(now) - ${start_time} ))
676
677 # Wait a little
678 sleep 1
679 done
69a6ec55 680 fi
f9783277
MT
681
682 # Returns the exit code of the child process
683 wait ${pid}
684 local ret=$?
685
686 if ! ${INTERACTIVE}; then
687 print_runtime $(( $(now) - ${start_time} ))
688 fi
689
690 return ${ret}
69a6ec55
MT
691}
692
693fake_environ() {
694 [ -e "${BASEDIR}/build${TOOLS_DIR}/lib/libpakfire_preload.so" ] || return
695
696 local env="LD_PRELOAD=${TOOLS_DIR}/lib/libpakfire_preload.so"
697
698 # Fake kernel version, because some of the packages do not compile
699 # with kernel 3.0 and later.
700 env="${env} UTS_RELEASE=${KVER}"
701
702 # Fake machine version.
703 env="${env} UTS_MACHINE=${BUILD_ARCH}"
704
705 echo "${env}"
706}
707
708qemu_environ() {
709 local env
710
711 # Don't add anything if qemu is not used.
712 if ! qemu_is_required; then
713 return
714 fi
715
716 # Set default qemu options
717 case "${BUILD_ARCH}" in
718 arm*)
719 QEMU_CPU="${QEMU_CPU:-cortex-a9}"
720
721 env="${env} QEMU_CPU=${QEMU_CPU}"
722 ;;
723 esac
724
725 # Enable QEMU strace
726 #env="${env} QEMU_STRACE=1"
727
728 echo "${env}"
729}
730
731qemu_is_required() {
732 local build_arch="${1}"
733
734 if [ -z "${build_arch}" ]; then
735 build_arch="${BUILD_ARCH}"
736 fi
737
738 case "${HOST_ARCH},${build_arch}" in
739 x86_64,arm*|i?86,arm*|i?86,x86_64)
740 return 0
741 ;;
742 *)
743 return 1
744 ;;
745 esac
746}
747
748qemu_install_helper() {
749 # Do nothing, if qemu is not required
750 if ! qemu_is_required; then
751 return 0
752 fi
753
754 if [ ! -e /proc/sys/fs/binfmt_misc/status ]; then
755 exiterror "binfmt_misc not mounted. QEMU_TARGET_HELPER not useable."
756 fi
757
758 if [ ! $(cat /proc/sys/fs/binfmt_misc/status) = 'enabled' ]; then
759 exiterror "binfmt_misc not enabled. QEMU_TARGET_HELPER not useable."
760 fi
761
762
763 if [ -z "${QEMU_TARGET_HELPER}" ]; then
764 exiterror "QEMU_TARGET_HELPER not set"
765 fi
766
767 # Check if the helper is already installed.
768 if [ -x "${LFS}${QEMU_TARGET_HELPER}" ]; then
769 return 0
770 fi
771
772 # Try to find a suitable binary that we can install
773 # to the build environment.
774 local file
775 for file in "${QEMU_TARGET_HELPER}" "${QEMU_TARGET_HELPER}-static"; do
776 # file must exist and be executable.
777 [ -x "${file}" ] || continue
778
779 # Must be static.
780 file_is_static "${file}" || continue
781
782 local dirname="${LFS}$(dirname "${file}")"
783 mkdir -p "${dirname}"
784
785 install -m 755 "${file}" "${LFS}${QEMU_TARGET_HELPER}"
786 return 0
787 done
788
789 exiterror "Could not find a statically-linked QEMU emulator: ${QEMU_TARGET_HELPER}"
790}
791
792qemu_find_build_helper_name() {
793 local build_arch="${1}"
794
795 local magic
796 case "${build_arch}" in
797 arm*)
798 magic="7f454c4601010100000000000000000002002800"
799 ;;
800 x86_64)
801 magic="7f454c4602010100000000000000000002003e00"
802 ;;
803 esac
804
805 [ -z "${magic}" ] && return 1
806
807 local file
808 for file in /proc/sys/fs/binfmt_misc/*; do
809 # skip write only register entry
810 [ $(basename "${file}") = "register" ] && continue
811 # Search for the file with the correct magic value.
812 grep -qE "^magic ${magic}$" "${file}" || continue
813
814 local interpreter="$(grep "^interpreter" "${file}" | awk '{ print $2 }')"
815
816 [ -n "${interpreter}" ] || continue
817 [ "${interpreter:0:1}" = "/" ] || continue
818 [ -x "${interpreter}" ] || continue
819
820 echo "${interpreter}"
821 return 0
822 done
823
824 return 1
825}
826
827file_is_static() {
828 local file="${1}"
829
830 file ${file} 2>/dev/null | grep -q "statically linked"
831}
832
833update_language_list() {
834 local path="${1}"
835
836 local lang
837 for lang in ${path}/*.po; do
838 lang="$(basename "${lang}")"
839 echo "${lang%*.po}"
840 done | sort -u > "${path}/LINGUAS"
841}
842
a98ab1d7
MT
843# Load configuration file
844if [ -f .config ]; then
845 . .config
846fi
847
813659f2
MT
848# TARGET_ARCH is BUILD_ARCH now
849if [ -n "${TARGET_ARCH}" ]; then
850 BUILD_ARCH="${TARGET_ARCH}"
851 unset TARGET_ARCH
852fi
853
5190eea2
MT
854# Get the amount of memory in this build system
855HOST_MEM=$(system_memory)
856
dc7d6b20
MT
857if [ -n "${BUILD_ARCH}" ]; then
858 configure_build "${BUILD_ARCH}"
949544f5 859else
dc7d6b20 860 configure_build "default"
949544f5
MT
861fi
862
df5e82b3 863buildtoolchain() {
69a6ec55
MT
864 local error=false
865 case "${BUILD_ARCH}:${HOST_ARCH}" in
866 # x86_64
867 x86_64:x86_64)
868 # This is working.
869 ;;
870
871 # x86
872 i586:i586|i586:i686|i586:x86_64)
873 # These are working.
874 ;;
875 i586:*)
876 error=true
877 ;;
878
879 # ARM
880 arvm7hl:armv7hl|armv7hl:armv7l)
881 # These are working.
882 ;;
883
884 armv5tel:armv5tel|armv5tel:armv5tejl|armv5tel:armv6l|armv5tel:armv7l|armv5tel:aarch64)
885 # These are working.
886 ;;
887 armv5tel:*)
888 error=true
889 ;;
890 esac
891
892 ${error} && \
893 exiterror "Cannot build ${BUILD_ARCH} toolchain on $(uname -m). Please use the download if any."
894
895 local gcc=$(type -p gcc)
896 if [ -z "${gcc}" ]; then
897 exiterror "Could not find GCC. You will need a working build enviroment in order to build the toolchain."
898 fi
899
6bd3a131
MT
900 # Check ${TOOLS_DIR} symlink
901 if [ -h "${TOOLS_DIR}" ]; then
902 rm -f "${TOOLS_DIR}"
903 fi
904
905 if [ ! -e "${TOOLS_DIR}" ]; then
906 ln -s "${BASEDIR}/build${TOOLS_DIR}" "${TOOLS_DIR}"
907 fi
908
909 if [ ! -h "${TOOLS_DIR}" ]; then
910 exiterror "Could not create ${TOOLS_DIR} symbolic link"
911 fi
912
69a6ec55
MT
913 LOGFILE="$BASEDIR/log/_build.toolchain.log"
914 export LOGFILE
915
916 lfsmake1 stage1
917 lfsmake1 ccache PASS=1
918 lfsmake1 binutils PASS=1
919 lfsmake1 gcc PASS=1
920 lfsmake1 linux KCFG="-headers"
921 lfsmake1 glibc
922 lfsmake1 gcc PASS=L
923 lfsmake1 binutils PASS=2
924 lfsmake1 gcc PASS=2
925 lfsmake1 ccache PASS=2
926 lfsmake1 tcl
927 lfsmake1 expect
928 lfsmake1 dejagnu
929 lfsmake1 pkg-config
930 lfsmake1 ncurses
931 lfsmake1 bash
932 lfsmake1 bzip2
933 lfsmake1 automake
934 lfsmake1 coreutils
935 lfsmake1 diffutils
936 lfsmake1 findutils
937 lfsmake1 gawk
938 lfsmake1 gettext
939 lfsmake1 grep
940 lfsmake1 gzip
941 lfsmake1 m4
942 lfsmake1 make
943 lfsmake1 patch
944 lfsmake1 perl
945 lfsmake1 sed
946 lfsmake1 tar
947 lfsmake1 texinfo
948 lfsmake1 xz
949 lfsmake1 fake-environ
7b93b62b 950 lfsmake1 strip
69a6ec55 951 lfsmake1 cleanup-toolchain
df5e82b3
MT
952}
953
954buildbase() {
69a6ec55
MT
955 LOGFILE="$BASEDIR/log/_build.base.log"
956 export LOGFILE
957 lfsmake2 stage2
958 lfsmake2 linux KCFG="-headers"
959 lfsmake2 man-pages
960 lfsmake2 glibc
961 lfsmake2 tzdata
962 lfsmake2 cleanup-toolchain
963 lfsmake2 zlib
964 lfsmake2 binutils
965 lfsmake2 gmp
966 lfsmake2 gmp-compat
967 lfsmake2 mpfr
968 lfsmake2 libmpc
969 lfsmake2 file
970 lfsmake2 gcc
971 lfsmake2 sed
972 lfsmake2 autoconf
973 lfsmake2 automake
974 lfsmake2 berkeley
975 lfsmake2 coreutils
976 lfsmake2 iana-etc
977 lfsmake2 m4
978 lfsmake2 bison
979 lfsmake2 ncurses-compat
980 lfsmake2 ncurses
981 lfsmake2 procps
982 lfsmake2 libtool
983 lfsmake2 perl
984 lfsmake2 readline
985 lfsmake2 readline-compat
986 lfsmake2 bzip2
987 lfsmake2 pcre
988 lfsmake2 pcre-compat
989 lfsmake2 bash
990 lfsmake2 diffutils
991 lfsmake2 e2fsprogs
992 lfsmake2 ed
993 lfsmake2 findutils
994 lfsmake2 flex
995 lfsmake2 gawk
996 lfsmake2 gettext
997 lfsmake2 grep
998 lfsmake2 groff
999 lfsmake2 gperf
1000 lfsmake2 gzip
1001 lfsmake2 hostname
1002 lfsmake2 iproute2
1003 lfsmake2 jwhois
1004 lfsmake2 kbd
1005 lfsmake2 less
1006 lfsmake2 make
1007 lfsmake2 man
1008 lfsmake2 kmod
1009 lfsmake2 net-tools
1010 lfsmake2 patch
1011 lfsmake2 psmisc
1012 lfsmake2 shadow
1013 lfsmake2 sysklogd
1014 lfsmake2 sysvinit
1015 lfsmake2 tar
1016 lfsmake2 texinfo
1017 lfsmake2 util-linux
1018 lfsmake2 udev
1019 lfsmake2 vim
1020 lfsmake2 xz
1021 lfsmake2 paxctl
df5e82b3
MT
1022}
1023
15679d9f 1024buildipfire() {
907cd036 1025 LOGFILE="$BASEDIR/log/_build.ipfire.log"
df5e82b3 1026 export LOGFILE
489145db
MT
1027 lfsmake2 configroot
1028 lfsmake2 initscripts
1029 lfsmake2 backup
1030 lfsmake2 pkg-config
1031 lfsmake2 libusb
1032 lfsmake2 libusb-compat
1033 lfsmake2 libpcap
1034 lfsmake2 ppp
1035 lfsmake2 pptp
1036 lfsmake2 unzip
1037 lfsmake2 which
1038 lfsmake2 linux-firmware
1039 lfsmake2 ath10k-firmware
1040 lfsmake2 dvb-firmwares
1041 lfsmake2 mt7601u-firmware
1042 lfsmake2 zd1211-firmware
1043 lfsmake2 rpi-firmware
1044 lfsmake2 bc
1045 lfsmake2 u-boot
1046 lfsmake2 cpio
1047 lfsmake2 mdadm
1048 lfsmake2 dracut
1049 lfsmake2 lvm2
1050 lfsmake2 multipath-tools
1051 lfsmake2 freetype
1052 lfsmake2 grub
1053 lfsmake2 libmnl
1054 lfsmake2 libnfnetlink
1055 lfsmake2 libnetfilter_queue
1056 lfsmake2 libnetfilter_conntrack
1057 lfsmake2 libnetfilter_cthelper
1058 lfsmake2 libnetfilter_cttimeout
1059 lfsmake2 iptables
8e6fb99d 1060
dc7d6b20 1061 case "${BUILD_ARCH}" in
fc155193 1062 x86_64)
489145db
MT
1063 lfsmake2 linux KCFG=""
1064 lfsmake2 backports KCFG=""
1065 lfsmake2 e1000e KCFG=""
1066 lfsmake2 igb KCFG=""
1067 lfsmake2 ixgbe KCFG=""
1068 lfsmake2 xtables-addons KCFG=""
1069 lfsmake2 linux-initrd KCFG=""
fc155193 1070 ;;
3d02c091
MT
1071 i586)
1072 # x86-pae (Native and new XEN) kernel build
489145db
MT
1073 lfsmake2 linux KCFG="-pae"
1074 lfsmake2 backports KCFG="-pae"
1075 lfsmake2 e1000e KCFG="-pae"
1076 lfsmake2 igb KCFG="-pae"
1077 lfsmake2 ixgbe KCFG="-pae"
1078 lfsmake2 xtables-addons KCFG="-pae"
1079 lfsmake2 linux-initrd KCFG="-pae"
3d02c091
MT
1080
1081 # x86 kernel build
489145db
MT
1082 lfsmake2 linux KCFG=""
1083 lfsmake2 backports KCFG=""
1084 lfsmake2 e1000e KCFG=""
1085 lfsmake2 igb KCFG=""
1086 lfsmake2 ixgbe KCFG=""
1087 lfsmake2 xtables-addons KCFG=""
1088 lfsmake2 linux-initrd KCFG=""
3d02c091 1089 ;;
544f40d4 1090
3d02c091
MT
1091 armv5tel)
1092 # arm-rpi (Raspberry Pi) kernel build
489145db
MT
1093 lfsmake2 linux KCFG="-rpi"
1094 lfsmake2 backports KCFG="-rpi"
1095 lfsmake2 xtables-addons KCFG="-rpi"
1096 lfsmake2 linux-initrd KCFG="-rpi"
3d02c091
MT
1097
1098 # arm multi platform (Panda, Wandboard ...) kernel build
489145db
MT
1099 lfsmake2 linux KCFG="-multi"
1100 lfsmake2 backports KCFG="-multi"
1101 lfsmake2 e1000e KCFG="-multi"
1102 lfsmake2 igb KCFG="-multi"
1103 lfsmake2 ixgbe KCFG="-multi"
1104 lfsmake2 xtables-addons KCFG="-multi"
1105 lfsmake2 linux-initrd KCFG="-multi"
3d02c091
MT
1106
1107 # arm-kirkwood (Dreamplug, ICY-Box ...) kernel build
489145db
MT
1108 lfsmake2 linux KCFG="-kirkwood"
1109 lfsmake2 backports KCFG="-kirkwood"
1110 lfsmake2 e1000e KCFG="-kirkwood"
1111 lfsmake2 igb KCFG="-kirkwood"
1112 lfsmake2 ixgbe KCFG="-kirkwood"
1113 lfsmake2 xtables-addons KCFG="-kirkwood"
1114 lfsmake2 linux-initrd KCFG="-kirkwood"
3d02c091
MT
1115 ;;
1116 esac
489145db
MT
1117 lfsmake2 xtables-addons USPACE="1"
1118 lfsmake2 openssl
1119 [ "${BUILD_ARCH}" = "i586" ] && lfsmake2 openssl KCFG='-sse2'
1120 lfsmake2 libgpg-error
1121 lfsmake2 libgcrypt
1122 lfsmake2 libassuan
1123 lfsmake2 nettle
1124 lfsmake2 libevent
1125 lfsmake2 libevent2
89ad036a 1126 lfsmake2 libevent2-compat
489145db 1127 lfsmake2 expat
c8e9a7a8
WA
1128 lfsmake2 apr
1129 lfsmake2 aprutil
489145db
MT
1130 lfsmake2 unbound
1131 lfsmake2 gnutls
1132 lfsmake2 bind
1133 lfsmake2 dhcp
1134 lfsmake2 dhcpcd
1135 lfsmake2 boost
1136 lfsmake2 linux-atm
1137 lfsmake2 gdbm
1138 lfsmake2 pam
1139 lfsmake2 curl
1140 lfsmake2 tcl
1141 lfsmake2 sqlite
1142 lfsmake2 libffi
1143 lfsmake2 python
1144 lfsmake2 python3
1145 lfsmake2 ca-certificates
1146 lfsmake2 fireinfo
1147 lfsmake2 libnet
1148 lfsmake2 libnl
1149 lfsmake2 libnl-3
1150 lfsmake2 libidn
1151 lfsmake2 nasm
1152 lfsmake2 libjpeg
1153 lfsmake2 libjpeg-compat
1154 lfsmake2 libexif
1155 lfsmake2 libpng
1156 lfsmake2 libtiff
1157 lfsmake2 libart
1158 lfsmake2 gd
1159 lfsmake2 popt
489145db
MT
1160 lfsmake2 slang
1161 lfsmake2 newt
1162 lfsmake2 libsmooth
1163 lfsmake2 attr
1164 lfsmake2 acl
1165 lfsmake2 libcap
1166 lfsmake2 pciutils
1167 lfsmake2 usbutils
1168 lfsmake2 libxml2
1169 lfsmake2 libxslt
1170 lfsmake2 BerkeleyDB
1171 lfsmake2 mysql
1172 lfsmake2 cyrus-sasl
1173 lfsmake2 openldap
1174 lfsmake2 apache2
1175 lfsmake2 php
1176 lfsmake2 web-user-interface
1177 lfsmake2 flag-icons
1178 lfsmake2 jquery
6033b271 1179 lfsmake2 bootstrap
489145db
MT
1180 lfsmake2 arping
1181 lfsmake2 beep
1182 lfsmake2 dvdrtools
1183 lfsmake2 dosfstools
1184 lfsmake2 reiserfsprogs
1185 lfsmake2 xfsprogs
1186 lfsmake2 sysfsutils
1187 lfsmake2 fuse
1188 lfsmake2 ntfs-3g
1189 lfsmake2 ethtool
1190 lfsmake2 ez-ipupdate
1191 lfsmake2 fcron
1192 lfsmake2 perl-GD
1193 lfsmake2 GD-Graph
1194 lfsmake2 GD-TextUtil
1195 lfsmake2 perl-Device-SerialPort
1196 lfsmake2 perl-Device-Modem
1197 lfsmake2 perl-Apache-Htpasswd
1198 lfsmake2 gnupg
1199 lfsmake2 hdparm
1200 lfsmake2 sdparm
1201 lfsmake2 mtools
1202 lfsmake2 whatmask
1203 lfsmake2 conntrack-tools
1204 lfsmake2 libupnp
1205 lfsmake2 ipaddr
1206 lfsmake2 iputils
1207 lfsmake2 l7-protocols
1208 lfsmake2 mISDNuser
1209 lfsmake2 capi4k-utils
1210 lfsmake2 hwdata
1211 lfsmake2 logrotate
1212 lfsmake2 logwatch
1213 lfsmake2 misc-progs
1214 lfsmake2 nano
1215 lfsmake2 URI
1216 lfsmake2 HTML-Tagset
1217 lfsmake2 HTML-Parser
1218 lfsmake2 HTML-Template
1219 lfsmake2 Compress-Zlib
1220 lfsmake2 Digest
1221 lfsmake2 Digest-SHA1
1222 lfsmake2 Digest-HMAC
1223 lfsmake2 libwww-perl
1224 lfsmake2 Net-DNS
1225 lfsmake2 Net-IPv4Addr
1226 lfsmake2 Net_SSLeay
1227 lfsmake2 IO-Stringy
1228 lfsmake2 IO-Socket-SSL
1229 lfsmake2 Unix-Syslog
1230 lfsmake2 Mail-Tools
1231 lfsmake2 MIME-Tools
1232 lfsmake2 Net-Server
1233 lfsmake2 Convert-TNEF
1234 lfsmake2 Convert-UUlib
1235 lfsmake2 Archive-Tar
1236 lfsmake2 Archive-Zip
1237 lfsmake2 Text-Tabs+Wrap
1238 lfsmake2 Locale-Country
1239 lfsmake2 XML-Parser
1240 lfsmake2 Crypt-PasswdMD5
1241 lfsmake2 Net-Telnet
1242 lfsmake2 python-setuptools
1243 lfsmake2 python-clientform
1244 lfsmake2 python-mechanize
1245 lfsmake2 python-feedparser
1246 lfsmake2 python-rssdler
1247 lfsmake2 python-inotify
1248 lfsmake2 python-docutils
1249 lfsmake2 python-daemon
1250 lfsmake2 python-ipaddress
1251 lfsmake2 glib
1252 lfsmake2 GeoIP
489145db
MT
1253 lfsmake2 noip_updater
1254 lfsmake2 ntp
1255 lfsmake2 openssh
1256 lfsmake2 fontconfig
1257 lfsmake2 dejavu-fonts-ttf
70f6cba4 1258 lfsmake2 ubuntu-font-family
489145db
MT
1259 lfsmake2 freefont
1260 lfsmake2 pixman
1261 lfsmake2 cairo
1262 lfsmake2 pango
1263 lfsmake2 rrdtool
1264 lfsmake2 setserial
1265 lfsmake2 setup
1266 lfsmake2 libdnet
1267 lfsmake2 daq
1268 lfsmake2 snort
1269 lfsmake2 oinkmaster
1270 lfsmake2 squid
1271 lfsmake2 squidguard
1272 lfsmake2 calamaris
1273 lfsmake2 tcpdump
1274 lfsmake2 traceroute
1275 lfsmake2 vlan
1276 lfsmake2 wireless
1277 lfsmake2 pakfire
1278 lfsmake2 spandsp
1279 lfsmake2 lzo
1280 lfsmake2 openvpn
1281 lfsmake2 pammysql
1282 lfsmake2 mpage
1283 lfsmake2 dbus
1284 lfsmake2 intltool
1285 lfsmake2 libdaemon
1286 lfsmake2 cups
489145db 1287 lfsmake2 lcms2
56170c2a 1288 lfsmake2 ghostscript
489145db
MT
1289 lfsmake2 qpdf
1290 lfsmake2 poppler
1291 lfsmake2 cups-filters
1292 lfsmake2 epson-inkjet-printer-escpr
1293 lfsmake2 foomatic
1294 lfsmake2 hplip
1295 lfsmake2 cifs-utils
1296 lfsmake2 krb5
1297 lfsmake2 samba
1298 lfsmake2 sudo
1299 lfsmake2 mc
1300 lfsmake2 wget
1301 lfsmake2 bridge-utils
1302 lfsmake2 screen
1303 lfsmake2 smartmontools
1304 lfsmake2 htop
1305 lfsmake2 chkconfig
1306 lfsmake2 postfix
1307 lfsmake2 fetchmail
1308 lfsmake2 cyrus-imapd
1309 lfsmake2 openmailadmin
1310 lfsmake2 clamav
1311 lfsmake2 spamassassin
1312 lfsmake2 amavisd
1313 lfsmake2 dma
1314 lfsmake2 alsa
1315 lfsmake2 mpfire
1316 lfsmake2 guardian
1317 lfsmake2 libid3tag
1318 lfsmake2 libmad
1319 lfsmake2 libogg
1320 lfsmake2 libvorbis
1321 lfsmake2 libdvbpsi
1322 lfsmake2 flac
1323 lfsmake2 lame
1324 lfsmake2 sox
1325 lfsmake2 libshout
1326 lfsmake2 xvid
1327 lfsmake2 libmpeg2
1328 lfsmake2 libarchive
1329 lfsmake2 cmake
1330 lfsmake2 gnump3d
1331 lfsmake2 rsync
1332 lfsmake2 tcpwrapper
1333 lfsmake2 libtirpc
1334 lfsmake2 rpcbind
1335 lfsmake2 nfs
1336 lfsmake2 gnu-netcat
1337 lfsmake2 ncat
1338 lfsmake2 nmap
489145db
MT
1339 lfsmake2 etherwake
1340 lfsmake2 bwm-ng
1341 lfsmake2 sysstat
489145db
MT
1342 lfsmake2 strongswan
1343 lfsmake2 rng-tools
1344 lfsmake2 lsof
1345 lfsmake2 br2684ctl
1346 lfsmake2 pcmciautils
1347 lfsmake2 lm_sensors
1348 lfsmake2 liboping
1349 lfsmake2 collectd
1350 lfsmake2 elinks
1351 lfsmake2 igmpproxy
1352 lfsmake2 fbset
1353 lfsmake2 opus
1354 lfsmake2 python-six
1355 lfsmake2 python-pyparsing
1356 lfsmake2 spice-protocol
1357 lfsmake2 spice
1358 lfsmake2 sdl
1359 lfsmake2 libusbredir
1360 lfsmake2 qemu
1361 lfsmake2 sane
1362 lfsmake2 netpbm
1363 lfsmake2 phpSANE
1364 lfsmake2 tunctl
1365 lfsmake2 netsnmpd
1366 lfsmake2 nagios
1367 lfsmake2 nagios_nrpe
1368 lfsmake2 icinga
1369 lfsmake2 ebtables
1370 lfsmake2 directfb
489145db
MT
1371 lfsmake2 faad2
1372 lfsmake2 ffmpeg
1373 lfsmake2 vdr
1374 lfsmake2 vdr_streamdev
489145db
MT
1375 lfsmake2 vdr_epgsearch
1376 lfsmake2 vdr_dvbapi
1377 lfsmake2 vdr_eepg
1378 lfsmake2 w_scan
1379 lfsmake2 icecast
1380 lfsmake2 icegenerator
1381 lfsmake2 mpd
1382 lfsmake2 libmpdclient
1383 lfsmake2 mpc
1384 lfsmake2 perl-Net-SMTP-SSL
1385 lfsmake2 perl-MIME-Base64
1386 lfsmake2 perl-Authen-SASL
1387 lfsmake2 perl-MIME-Lite
1388 lfsmake2 perl-Email-Date-Format
1389 lfsmake2 git
1390 lfsmake2 squidclamav
1391 lfsmake2 vnstat
1392 lfsmake2 iw
1393 lfsmake2 wpa_supplicant
1394 lfsmake2 hostapd
1395 lfsmake2 pycurl
1396 lfsmake2 urlgrabber
1397 lfsmake2 syslinux
1398 lfsmake2 tftpd
1399 lfsmake2 cpufrequtils
1400 lfsmake2 bluetooth
1401 lfsmake2 gutenprint
1402 lfsmake2 apcupsd
1403 lfsmake2 iperf
1404 lfsmake2 iperf3
1405 lfsmake2 7zip
1406 lfsmake2 lynis
1407 lfsmake2 streamripper
1408 lfsmake2 sshfs
1409 lfsmake2 taglib
1410 #lfsmake2 mediatomb
1411 lfsmake2 sslh
1412 lfsmake2 perl-gettext
1413 lfsmake2 perl-Sort-Naturally
1414 lfsmake2 vdradmin
1415 lfsmake2 miau
1416 lfsmake2 perl-DBI
1417 lfsmake2 perl-DBD-mysql
1418 lfsmake2 perl-DBD-SQLite
1419 lfsmake2 perl-File-ReadBackwards
1420 lfsmake2 cacti
1421 lfsmake2 openvmtools
1422 lfsmake2 nagiosql
489145db
MT
1423 lfsmake2 motion
1424 lfsmake2 joe
1425 lfsmake2 monit
1426 lfsmake2 nut
1427 lfsmake2 watchdog
1428 lfsmake2 libpri
1429 lfsmake2 libsrtp
1430 lfsmake2 asterisk
1431 lfsmake2 lcr
1432 lfsmake2 usb_modeswitch
1433 lfsmake2 usb_modeswitch_data
1434 lfsmake2 zerofree
489145db
MT
1435 lfsmake2 minicom
1436 lfsmake2 ddrescue
489145db
MT
1437 lfsmake2 miniupnpd
1438 lfsmake2 client175
1439 lfsmake2 powertop
1440 lfsmake2 parted
1441 lfsmake2 swig
1442 lfsmake2 python-m2crypto
1443 lfsmake2 wireless-regdb
1444 lfsmake2 crda
1445 lfsmake2 libsolv
1446 lfsmake2 python-distutils-extra
1447 lfsmake2 python-lzma
1448 lfsmake2 python-progressbar
1449 lfsmake2 python-xattr
1450 lfsmake2 ddns
1451 lfsmake2 transmission
1452 lfsmake2 dpfhack
1453 lfsmake2 lcd4linux
1454 lfsmake2 mtr
489145db
MT
1455 lfsmake2 minidlna
1456 lfsmake2 acpid
1457 lfsmake2 fping
1458 lfsmake2 telnet
1459 lfsmake2 xinetd
1460 lfsmake2 gpgme
1461 lfsmake2 pygpgme
1462 lfsmake2 pakfire3
1463 lfsmake2 stress
1464 lfsmake2 libstatgrab
1465 lfsmake2 sarg
1466 lfsmake2 check_mk_agent
1467 lfsmake2 nginx
1468 lfsmake2 sendEmail
1469 lfsmake2 sysbench
1470 lfsmake2 strace
1471 lfsmake2 elfutils
1472 lfsmake2 ltrace
1473 lfsmake2 ipfire-netboot
1474 lfsmake2 lcdproc
1475 lfsmake2 bitstream
1476 lfsmake2 multicat
1477 lfsmake2 keepalived
1478 lfsmake2 ipvsadm
1479 lfsmake2 perl-Carp-Clan
1480 lfsmake2 perl-Date-Calc
1481 lfsmake2 perl-Date-Manip
1482 lfsmake2 perl-File-Tail
1483 lfsmake2 perl-TimeDate
1484 lfsmake2 swatch
1485 lfsmake2 tor
1486 lfsmake2 arm
1487 lfsmake2 wavemon
1488 lfsmake2 iptraf-ng
1489 lfsmake2 iotop
1490 lfsmake2 stunnel
489145db
MT
1491 lfsmake2 owncloud
1492 lfsmake2 bacula
1493 lfsmake2 batctl
b62c826f
MT
1494 lfsmake2 perl-Font-TTF
1495 lfsmake2 perl-IO-String
489145db
MT
1496 lfsmake2 perl-PDF-API2
1497 lfsmake2 squid-accounting
1498 lfsmake2 pigz
1499 lfsmake2 tmux
1500 lfsmake2 perl-Text-CSV_XS
1501 lfsmake2 swconfig
1502 lfsmake2 haproxy
1503 lfsmake2 ipset
1504 lfsmake2 lua
1505 lfsmake2 dnsdist
1506 lfsmake2 bird
1507 lfsmake2 dmidecode
1508 lfsmake2 mcelog
1509 lfsmake2 rtpproxy
1510 lfsmake2 util-macros
1511 lfsmake2 libpciaccess
1512 lfsmake2 libyajl
1513 lfsmake2 libvirt
b190cbe2 1514 lfsmake2 python3-libvirt
489145db
MT
1515 lfsmake2 freeradius
1516 lfsmake2 perl-common-sense
1517 lfsmake2 perl-inotify2
1518 lfsmake2 perl-Net-IP
0d6cc79d 1519 lfsmake2 wio
773caa66 1520 lfsmake2 iftop
d0817963 1521}
df5e82b3
MT
1522
1523buildinstaller() {
1524 # Run installer scripts one by one
1525 LOGFILE="$BASEDIR/log/_build.installer.log"
1526 export LOGFILE
489145db
MT
1527 lfsmake2 memtest
1528 lfsmake2 installer
ce9264a1
AF
1529 # use toolchain bash for chroot to strip
1530 EXTRA_PATH=${TOOLS_DIR}/bin/ lfsmake2 strip
df5e82b3
MT
1531}
1532
1533buildpackages() {
1534 LOGFILE="$BASEDIR/log/_build.packages.log"
1535 export LOGFILE
1536 echo "... see detailed log in _build.*.log files" >> $LOGFILE
0fbb45e9 1537
df5e82b3
MT
1538
1539 # Generating list of packages used
dc4ae0b7 1540 print_line "Generating packages list from logs"
df5e82b3
MT
1541 rm -f $BASEDIR/doc/packages-list
1542 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
1543 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
7471f6ab 1544 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
df5e82b3
MT
1545 fi
1546 done
7471f6ab 1547 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
4fe9acb2 1548 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
df5e82b3
MT
1549 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
1550 rm -f $BASEDIR/doc/packages-list
c9673262 1551 # packages-list.txt is ready to be displayed for wiki page
f9783277 1552 print_status DONE
4b06f504
MT
1553
1554 # Update changelog
e49f7f0d 1555 cd $BASEDIR
c43b07fd
AF
1556 [ -z $GIT_TAG ] || LAST_TAG=$GIT_TAG
1557 [ -z $LAST_TAG ] || EXT="$LAST_TAG..HEAD"
1558 git log -n 500 --no-merges --pretty=medium --shortstat $EXT > $BASEDIR/doc/ChangeLog
df5e82b3 1559
9607771a 1560 # Create images for install
489145db 1561 lfsmake2 cdrom
bada0832 1562
4dc82852 1563 # Check if there is a loop device for building in virtual environments
841663e7
MT
1564 modprobe loop 2>/dev/null
1565 if [ $BUILD_IMAGES == 1 ] && ([ -e /dev/loop/0 ] || [ -e /dev/loop0 ] || [ -e "/dev/loop-control" ]); then
489145db
MT
1566 lfsmake2 flash-images
1567 lfsmake2 flash-images SCON=1
4dc82852 1568 fi
c9673262 1569
f0fc8807 1570 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz,*.bz2} $BASEDIR >> $LOGFILE 2>&1
c9673262 1571
0d909a4a 1572 ipfirepackages
e67a57fe 1573
489145db 1574 lfsmake2 xen-image
939c2a21 1575 mv $LFS/install/images/*.bz2 $BASEDIR >> $LOGFILE 2>&1
bada0832 1576
b307417f 1577 cd $BASEDIR
744a04ea
AF
1578
1579 # remove not useable iso on armv5tel (needed to build flash images)
dc7d6b20 1580 [ "${BUILD_ARCH}" = "armv5tel" ] && rm -rf *.iso
744a04ea 1581
b307417f
AF
1582 for i in `ls *.bz2 *.img.gz *.iso`; do
1583 md5sum $i > $i.md5
1584 done
1585 cd $PWD
1586
e67a57fe
MT
1587 # Cleanup
1588 stdumount
1589 rm -rf $BASEDIR/build/tmp/*
1590
e67a57fe 1591 cd $PWD
e67a57fe
MT
1592}
1593
1594ipfirepackages() {
489145db 1595 lfsmake2 core-updates
5596077b
MT
1596
1597 local i
dc7d6b20 1598 for i in $(find $BASEDIR/config/rootfiles/packages{/${BUILD_ARCH},} -maxdepth 1 -type f); do
5596077b 1599 i=$(basename ${i})
453b418b
MT
1600 if [ -e $BASEDIR/lfs/$i ]; then
1601 ipfiredist $i
1602 else
1603 echo -n $i
f9783277 1604 print_status SKIP
453b418b 1605 fi
fe7fe395 1606 done
78331e30 1607 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
5c8cfc99 1608 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
483f59cd 1609 rm -rf $BASEDIR/build/install/packages/*
df5e82b3
MT
1610}
1611
bcb9dc13
MT
1612while [ $# -gt 0 ]; do
1613 case "${1}" in
1614 --target=*)
c2e810de 1615 configure_build "${1#--target=}"
bcb9dc13
MT
1616 ;;
1617 -*)
1618 exiterror "Unknown configuration option: ${1}"
1619 ;;
1620 *)
1621 # Found a command, so exit options parsing.
1622 break
1623 ;;
1624 esac
1625 shift
1626done
1627
df5e82b3
MT
1628# See what we're supposed to do
1629case "$1" in
1630build)
f9783277
MT
1631 START_TIME=$(now)
1632
1633 # Clear screen
1634 ${INTERACTIVE} && clear
1635
f74072a2 1636 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz 2> /dev/null | head -n 1`
df5e82b3 1637 #only restore on a clean disk
6c4cc7ea 1638 if [ ! -e "${BASEDIR}/build${TOOLS_DIR}/.toolchain-successful" ]; then
df5e82b3 1639 if [ ! -n "$PACKAGE" ]; then
f9783277 1640 print_build_stage "Full toolchain compilation"
df5e82b3
MT
1641 prepareenv
1642 buildtoolchain
1643 else
f74072a2 1644 PACKAGENAME=${PACKAGE%.tar.xz}
f9783277 1645 print_build_stage "Packaged toolchain compilation"
df5e82b3 1646 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
f74072a2 1647 tar axf $PACKAGE
df5e82b3
MT
1648 prepareenv
1649 else
1650 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
1651 fi
1652 fi
1653 else
df5e82b3
MT
1654 prepareenv
1655 fi
5cfe86e6 1656
f9783277 1657 print_build_stage "Building LFS"
df5e82b3 1658 buildbase
15679d9f 1659
f9783277 1660 print_build_stage "Building IPFire"
15679d9f 1661 buildipfire
5cfe86e6 1662
f9783277 1663 print_build_stage "Building installer"
df5e82b3 1664 buildinstaller
15679d9f 1665
f9783277 1666 print_build_stage "Building packages"
df5e82b3 1667 buildpackages
7a5ed24e 1668
f9783277 1669 print_build_stage "Checking Logfiles for new Files"
b307417f
AF
1670
1671 cd $BASEDIR
7a5ed24e 1672 tools/checknewlog.pl
e0c923f4 1673 tools/checkrootfiles
b307417f 1674 cd $PWD
a23731d1 1675
f9783277 1676 print_build_summary $(( $(now) - ${START_TIME} ))
df5e82b3
MT
1677 ;;
1678shell)
1679 # enter a shell inside LFS chroot
1680 # may be used to changed kernel settings
1681 prepareenv
1682 entershell
1683 ;;
df5e82b3 1684clean)
f9783277
MT
1685 print_line "Cleaning build directory..."
1686
df5e82b3
MT
1687 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
1688 $LOSETUP -d $i 2>/dev/null
1689 done
1690 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
1691 umount $i
1692 done
1693 stdumount
1694 for i in `seq 0 7`; do
69a6ec55 1695 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
df5e82b3
MT
1696 umount /dev/loop${i} 2>/dev/null;
1697 losetup -d /dev/loop${i} 2>/dev/null;
69a6ec55 1698 fi;
df5e82b3
MT
1699 done
1700 rm -rf $BASEDIR/build
1701 rm -rf $BASEDIR/cdrom
f9315063 1702 rm -rf $BASEDIR/packages
df5e82b3 1703 rm -rf $BASEDIR/log
6c4cc7ea
MT
1704 if [ -h "${TOOLS_DIR}" ]; then
1705 rm -f "${TOOLS_DIR}"
df5e82b3 1706 fi
b307417f 1707 rm -f $BASEDIR/ipfire-*
f9783277 1708 print_status DONE
df5e82b3 1709 ;;
c3db995c 1710downloadsrc)
df5e82b3
MT
1711 if [ ! -d $BASEDIR/cache ]; then
1712 mkdir $BASEDIR/cache
1713 fi
1714 mkdir -p $BASEDIR/log
857d9bf2 1715 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
df5e82b3
MT
1716 FINISHED=0
1717 cd $BASEDIR/lfs
1718 for c in `seq $MAX_RETRIES`; do
1719 if (( FINISHED==1 )); then
1720 break
1721 fi
1722 FINISHED=1
1723 cd $BASEDIR/lfs
1724 for i in *; do
1725 if [ -f "$i" -a "$i" != "Config" ]; then
846e756e
MT
1726 lfsmakecommoncheck ${i} || continue
1727
dc7d6b20 1728 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
51f9e7ac 1729 MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
df5e82b3 1730 if [ $? -ne 0 ]; then
f9783277 1731 print_status FAIL
df5e82b3
MT
1732 FINISHED=0
1733 else
1734 if [ $c -eq 1 ]; then
f9783277 1735 print_status DONE
df5e82b3
MT
1736 fi
1737 fi
1738 fi
1739 done
1740 done
e22c7973 1741 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
df5e82b3
MT
1742 ERROR=0
1743 for i in *; do
1744 if [ -f "$i" -a "$i" != "Config" ]; then
a4130265 1745 lfsmakecommoncheck ${i} > /dev/null || continue
dc7d6b20 1746 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
51f9e7ac 1747 MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
df5e82b3 1748 if [ $? -ne 0 ]; then
e22c7973 1749 echo -ne "MD5 difference in lfs/$i"
f9783277 1750 print_status FAIL
df5e82b3
MT
1751 ERROR=1
1752 fi
1753 fi
1754 done
1755 if [ $ERROR -eq 0 ]; then
e22c7973 1756 echo -ne "${BOLD}all files md5sum match${NORMAL}"
f9783277 1757 print_status DONE
e22c7973
MT
1758 else
1759 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
f9783277 1760 print_status FAIL
df5e82b3 1761 fi
e22c7973 1762 cd - >/dev/null 2>&1
df5e82b3 1763 ;;
df5e82b3 1764toolchain)
f9783277
MT
1765 # Clear screen
1766 ${INTERACTIVE} && clear
1767
df5e82b3 1768 prepareenv
f3b7cf47 1769 print_build_stage "Toolchain compilation (${BUILD_ARCH})"
df5e82b3 1770 buildtoolchain
f74072a2 1771 echo "`date -u '+%b %e %T'`: Create toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
11104bfe 1772 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
f74072a2 1773 cd $BASEDIR && XZ_OPT="-T0 -8" tar -Jc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz \
6c4cc7ea 1774 build/${TOOLS_DIR} build/bin/sh log >> $LOGFILE
f74072a2 1775 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz \
dc7d6b20 1776 > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.md5
df5e82b3
MT
1777 stdumount
1778 ;;
1779gettoolchain)
df5e82b3 1780 # arbitrary name to be updated in case of new toolchain package upload
dc7d6b20 1781 PACKAGE=$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}
f74072a2 1782 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.xz ]; then
5bd13f01 1783 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
11104bfe 1784 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
f74072a2 1785 echo "`date -u '+%b %e %T'`: Load toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
712d859c 1786 cd $BASEDIR/cache/toolchains
f74072a2 1787 wget -U "IPFireSourceGrabber/2.x" $URL_TOOLCHAIN/$PACKAGE.tar.xz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
712d859c 1788 if [ $? -ne 0 ]; then
dc7d6b20 1789 echo "`date -u '+%b %e %T'`: error downloading $PACKAGE toolchain for ${BUILD_ARCH} machine" | tee -a $LOGFILE
40a4ea4c 1790 else
f74072a2 1791 if [ "`md5sum $PACKAGE.tar.xz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
712d859c
MT
1792 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
1793 else
1794 exiterror "$PACKAGE.md5 did not match, check downloaded package"
1795 fi
40a4ea4c 1796 fi
712d859c
MT
1797 else
1798 echo "Toolchain is already downloaded. Exiting..."
df5e82b3
MT
1799 fi
1800 ;;
15679d9f
MT
1801uploadsrc)
1802 PWD=`pwd`
661d9388
CS
1803 if [ -z $IPFIRE_USER ]; then
1804 echo -n "You have to setup IPFIRE_USER first. See .config for details."
f9783277 1805 print_status FAIL
661d9388
CS
1806 exit 1
1807 fi
ae23a606 1808
661d9388 1809 URL_SOURCE=$(grep URL_SOURCE lfs/Config | awk '{ print $3 }')
15e38431 1810 REMOTE_FILES=$(echo "ls -1" | sftp -C ${IPFIRE_USER}@${URL_SOURCE})
661d9388 1811
15e38431
MT
1812 for file in ${BASEDIR}/cache/*; do
1813 [ -d "${file}" ] && continue
1814 grep -q "$(basename ${file})" <<<$REMOTE_FILES && continue
661d9388 1815 NEW_FILES="$NEW_FILES $file"
0eab8e84 1816 done
661d9388
CS
1817 [ -n "$NEW_FILES" ] && scp -2 $NEW_FILES ${IPFIRE_USER}@${URL_SOURCE}
1818 cd $BASEDIR
15679d9f
MT
1819 cd $PWD
1820 exit 0
0eab8e84 1821 ;;
bf7c473f 1822lang)
69a6ec55
MT
1823 echo -ne "Checking the translations for missing or obsolete strings..."
1824 chmod 755 $BASEDIR/tools/{check_strings.pl,sort_strings.pl,check_langs.sh}
1825 $BASEDIR/tools/sort_strings.pl en
1826 $BASEDIR/tools/sort_strings.pl de
1827 $BASEDIR/tools/sort_strings.pl fr
1828 $BASEDIR/tools/sort_strings.pl es
1829 $BASEDIR/tools/sort_strings.pl pl
1830 $BASEDIR/tools/sort_strings.pl ru
1831 $BASEDIR/tools/sort_strings.pl nl
1832 $BASEDIR/tools/sort_strings.pl tr
1833 $BASEDIR/tools/sort_strings.pl it
1834 $BASEDIR/tools/check_strings.pl en > $BASEDIR/doc/language_issues.en
1835 $BASEDIR/tools/check_strings.pl de > $BASEDIR/doc/language_issues.de
1836 $BASEDIR/tools/check_strings.pl fr > $BASEDIR/doc/language_issues.fr
1837 $BASEDIR/tools/check_strings.pl es > $BASEDIR/doc/language_issues.es
1838 $BASEDIR/tools/check_strings.pl es > $BASEDIR/doc/language_issues.pl
1839 $BASEDIR/tools/check_strings.pl ru > $BASEDIR/doc/language_issues.ru
1840 $BASEDIR/tools/check_strings.pl nl > $BASEDIR/doc/language_issues.nl
1841 $BASEDIR/tools/check_strings.pl tr > $BASEDIR/doc/language_issues.tr
1842 $BASEDIR/tools/check_strings.pl it > $BASEDIR/doc/language_issues.it
1843 $BASEDIR/tools/check_langs.sh > $BASEDIR/doc/language_missings
f9783277 1844 print_status DONE
69a6ec55
MT
1845
1846 echo -ne "Updating language lists..."
1847 update_language_list ${BASEDIR}/src/installer/po
1848 update_language_list ${BASEDIR}/src/setup/po
f9783277 1849 print_status DONE
bf7c473f 1850 ;;
6b8cff41 1851*)
a50d04ab 1852 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
6b8cff41
MT
1853 cat doc/make.sh-usage
1854 ;;
3ea75603 1855esac